/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.productionunit;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;
import java.util.logging.Logger;
import nl.cloudfarming.client.farm.model.CropField;
import nl.cloudfarming.client.farm.model.CropProductionUnit;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Node;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
public class CropProductionUnitChildFactory extends ChildFactory<CropField> implements PropertyChangeListener {

    protected static final Logger LOGGER = Logger.getLogger("nl.cloudfarming.client.productionunit");
    private CropProductionUnit cropProductionUnit;

    public CropProductionUnitChildFactory(CropProductionUnit cropProductionUnit) {
        this.cropProductionUnit = cropProductionUnit;
        cropProductionUnit.addPropertyChangeListener(CropProductionUnit.PROP_CROPFIELDS, this);
    }

    @Override
    protected boolean createKeys(List<CropField> toPopulate) {
        toPopulate.addAll(cropProductionUnit.getCropFields());
        return true;
    }

    @Override
    protected Node createNodeForKey(CropField key) {
        return new CropFieldNode(key);
    }

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        refresh(true);
    }

}