/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.productionunit;

import java.awt.Image;
import java.awt.datatransfer.Transferable;
import java.util.ArrayList;
import java.util.List;
import javax.swing.Action;
import nl.cloudfarming.client.productionunit.wizard.NewCropProductionUnitAction;
import org.netbeans.api.project.Project;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.ImageUtilities;
import org.openide.util.NbBundle;
import org.openide.util.datatransfer.PasteType;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
@NbBundle.Messages({"CropProductionUnit_root_node_display_name=Production units"})
public class CropProductionUnitRootNode extends FilterNode {

    private static final String ICON = "nl/cloudfarming/client/productionunit/folder_green16.png";
    private Project project;

    public CropProductionUnitRootNode(Node original, Project project) {
        super(original, new FilterNode.Children(original), project.getLookup());
        this.project = project;
    }

    @Override
    public Image getIcon(int type) {
        return ImageUtilities.loadImage(ICON);
    }

    @Override
    public Image getOpenedIcon(int type) {
        return getIcon(type);
    }

    @Override
    public String getDisplayName() {
        return Bundle.CropProductionUnit_root_node_display_name();
    }

    @Override
    public Action[] getActions(boolean context) {
        List<Action> actions = new ArrayList<>();

        actions.add(new NewCropProductionUnitAction(project));

        return actions.toArray(new Action[actions.size()]);
    }

    @Override
    public PasteType getDropType(Transferable t, int action, int index) {
        return null; //dropping other nodes on this node is not supported
    }
}
